      implicit real*8 (a-h,o-z)

      include 'CONSTCOM.'
      include 'PDFCOM.'

      real*8 termplus(20,20,0:50,100),termtotplus(20,20,0:50,100)
     ,      ,termdisp(20,20,100)

      real*8 xbhera(4)
      data xbhera/ 0.18d0, 0.25d0, 0.4d0, 0.65d0/

      data xmin,xmax,ecm / 1d-4, 8d-1, 319d0/

#ifdef TOYLH
      print *,'******THIS BENCH IS INAPPLICABLE FOR THE TOYLH PDFS'
      STOP
#endif

!  Set up constants, grid spacing, etc.
      call initgridconst

!  Set up the 3-flavour NNLO PDFs and fill the 3-flavour PDF grid
!  including the strong coupling values
      kschemepdf=0
      kordpdf=2
!  NNLO massless Wilson coefficients
      kordf2=2
      kordfl=3
      kordf3=2
!  Include the correction up to the NNLO for the heavy-quark coefficients
      kordhq=2
      msbarm=.true.
! Set the c-quark mass at the PDG'10 value
      rmass(8)=1.27
! The non-singlet contribution is included
      hqnons=.true.
! Variant A of the NNLO term in the heavy-quark electroproduction Wilson
! coefficient of Ref. [1205.5727] is selected
      ddnnlohq=0.

! Weak-mixing angle sine squared (PDG 2010)
      sintw2=0.23116d0
! Z-boson mass (PDG 2010)
      rmassp(41)=91.1876
! Vector and axial charged-lepton couplings
      vld=-0.5+2*sintw2
      ald=-0.5
      val2d=vld**2+ald**2

      nbin=30

      do kpdfset=0,npdftot
        call pdffillgrid  
        do kk=1,4
          xb=xbhera(kk)
          bmin=200d0
          bmax=min(3d4,xb*ecm**2)
          bin=(log(bmax)-log(bmin))/(nbin-1)
          do klum=1,3
            do nn=1,nbin
              q2=bmin*exp(bin*(nn-1))
              yb=q2/(ecm)**2/xb
              yplus=(1+(1-yb)**2)
              yminus=(1-(1-yb)**2)
              zsup=(1./(1.+rmassp(41)**2/q2)/(4*sintw2*(1-sintw2)))
! photon exchange contribution
              sig0=f2qcd(3,1,22,xb,q2) 
     -           - yb**2/yplus*flqcd(3,1,22,xb,q2)   
! Z-exchange contribution
              sigz2p=(f2qcd(3,1,23,xb,q2)*val2d  
     -    -  yb**2/yplus*flqcd(3,1,23,xb,q2)*val2d
     -    -  yminus/yplus*xb*f3qcd(3,1,23,xb,q2)*2*vld*ald)*zsup**2
              sigz2m=(f2qcd(3,1,23,xb,q2)*val2d  
     -    -  yb**2/yplus*flqcd(3,1,23,xb,q2)*val2d
     +    +  yminus/yplus*xb*f3qcd(3,1,23,xb,q2)*2*vld*ald)*zsup**2

! photon-Z inteferenece contribution
              sigzp=(f2qcd(3,1,25,xb,q2)*(-vld) 
     -    - yb**2/yplus*flqcd(3,1,25,xb,q2)*(-vld)
     -    - yminus/yplus*xb*f3qcd(3,1,25,xb,q2)*(-ald))*zsup
              sigzm=(f2qcd(3,1,25,xb,q2)*(-vld) 
     -    - yb**2/yplus*flqcd(3,1,25,xb,q2)*(-vld)
     +    + yminus/yplus*xb*f3qcd(3,1,25,xb,q2)*(-ald))*zsup

              if (klum.eq.1) termplus(klum,kk,kpdfset,nn)
     =    =sig0
              if (klum.eq.2) termplus(klum,kk,kpdfset,nn)
     =    =(sig0+sigzp+sigz2p)
              if (klum.eq.3) termplus(klum,kk,kpdfset,nn)
     =    =(sig0+sigzm+sigz2m)
           end do
          end do
        end do
      end do

      print *,'The reduced inclusive cross section',
     -' F_2 - Y**2/Y_+*F_L +- Y__/Y_+*xF_3 for the NC DIS of',
     -' unpolarised electrons/positrons off proton at c.m.s.',
     -'  energy of 319 GeV and for high-Q HERA kinematics',
     -' in the NNLO QCD approximation and the running-mass definition',
     -' (first column: the value of Bjorken variable x, the second',
     -' column: the momentum transferred squared (GeV^2),',
     - ' the third column: pure QED c.s.,',
     - ' the 4-th column: positron-proton c.s.,',
     - ' the 5-th column: electron-proton c.s.)'

      do kk=1,4
        xb=xbhera(kk)
        bmin=200d0
        bmax=min(3d4,xb*ecm**2)
        bin=(log(bmax)-log(bmin))/(nbin-1)
        do i=1,nbin
          q2=bmin*exp(bin*(i-1))
          do klum=1,3
            termdisp(klum,1,i)=0.

            do kpdfset=1,npdftot          
              termdisp(klum,kk,i)=termdisp(klum,kk,i)
     +       +(termplus(klum,kk,kpdfset,i)-termplus(klum,kk,0,i))**2
            enddo  
!  In the case of asymmetric PDF errors 
!  take average of the positive and negative ones  
#if defined(ABKM09) || defined(ABM11) || defined(ABM112)
          termdisp(klum,kk,i)=sqrt(termdisp(klum,kk,i))
#else
          termdisp(klum,kk,i)=sqrt(termdisp(klum,kk,i)/2.)
#endif

          end do

        write (*,fmt='(2e13.4,6(e13.4,a2,e10.4))') xb,q2
     ,        ,(termplus(ll,kk,0,i),'+-',termdisp(ll,kk,i),ll=1,3)
        end do
      end do

      stop
      end
