      implicit real*8 (a-h,o-z)

      INCLUDE 'CONSTCOM.'
      INCLUDE 'PDFCOM.'

      real*8 termplus(10,0:50,100),termtotplus(10,0:50,100)
     ,      ,termdisp(10,100)

!  Set up constants, grid spacing, etc.
      call initgridconst

!  Set up the NNLO PDFs
      kordpdf=2

!  Set the factorization scales
      rmuf1=165d0
      rmuf2=2d0

      bmin=0.01
      bmax=0.3
      nbin=40 
      bin=(log(bmax)-log(bmin))/(nbin-1)

      do kpdfset=0,npdftot
        do klum=1,2
!  The qluons at large scale, 5-flavour scheme 
          if (klum.eq.1) then 
!  Fill the 5-flavour PDF grid for the set #kpdfset
            kschemepdf=2
            call pdffillgrid
!  Loop over x
            do i=1,nbin
              xb=bmin*exp(bin*(i-1))
              termplus(klum,kpdfset,i)
     =   =xqg(1,xb,rmuf1**2,kschemepdf)
            end do
          end if
!  The gluons at small scale, 4-flavour scheme
          if (klum.eq.2) then 
!  Fill the 4-flavour PDF grid for the set #kpdfset
            kschemepdf=1
            call pdffillgrid
!  Loop over x
            do i=1,nbin
              xb=bmin*exp(bin*(i-1))
              termplus(klum,kpdfset,i)
     =   =xqg(1,xb,rmuf2**2,kschemepdf)
            end do
          end if 
        end do
      end do

      print *,' The gluon distribution with uncertainties', 
     -' (first column: the Bjorken variable x,',
     -' second column: the 5-flavour gluon distribution at the scale',
     -' of 165 GeV, third column: the 4-flavour', 
     -' gluon distribution at the scale of 2 GeV).'

      do i=1,nbin
        xb=bmin*exp(bin*(i-1))

        do klum=1,2
          termdisp(klum,i)=0.

          do kpdfset=1,npdftot          
            termdisp(klum,i)=termdisp(klum,i)
     +    +(termplus(klum,kpdfset,i)-termplus(klum,0,i))**2
          enddo  
!  In the case of asymmetric PDF errors 
!  take average of the positive and negative ones  
#if defined(ABKM09) || defined(ABM11) || defined(ABM12)
          termdisp(klum,i)=sqrt(termdisp(klum,i))
#else
          termdisp(klum,i)=sqrt(termdisp(klum,i)/2.)
#endif

        end do

        write (*,fmt='(e13.4,4(e13.4,a2,e10.4))') xb
     ,        ,(termplus(kk,0,i),'+-',termdisp(kk,i),kk=1,2)
      end do

      stop
      end
